// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from leo_msgs:msg/WheelStates.idl
// generated code does not contain a copyright notice

#include "leo_msgs/msg/detail/wheel_states__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_leo_msgs
const rosidl_type_hash_t *
leo_msgs__msg__WheelStates__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x0f, 0x0d, 0x02, 0x1d, 0x08, 0x93, 0xa0, 0x5d,
      0xc7, 0xa0, 0x68, 0x85, 0x43, 0xec, 0x38, 0xac,
      0x78, 0x5c, 0x35, 0xe6, 0xd5, 0xd0, 0xb4, 0x2f,
      0xff, 0x84, 0xbd, 0x2b, 0x41, 0xef, 0x1c, 0x27,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types
#include "builtin_interfaces/msg/detail/time__functions.h"

// Hashes for external referenced types
#ifndef NDEBUG
static const rosidl_type_hash_t builtin_interfaces__msg__Time__EXPECTED_HASH = {1, {
    0xb1, 0x06, 0x23, 0x5e, 0x25, 0xa4, 0xc5, 0xed,
    0x35, 0x09, 0x8a, 0xa0, 0xa6, 0x1a, 0x3e, 0xe9,
    0xc9, 0xb1, 0x8d, 0x19, 0x7f, 0x39, 0x8b, 0x0e,
    0x42, 0x06, 0xce, 0xa9, 0xac, 0xf9, 0xc1, 0x97,
  }};
#endif

static char leo_msgs__msg__WheelStates__TYPE_NAME[] = "leo_msgs/msg/WheelStates";
static char builtin_interfaces__msg__Time__TYPE_NAME[] = "builtin_interfaces/msg/Time";

// Define type names, field names, and default values
static char leo_msgs__msg__WheelStates__FIELD_NAME__stamp[] = "stamp";
static char leo_msgs__msg__WheelStates__FIELD_NAME__position[] = "position";
static char leo_msgs__msg__WheelStates__FIELD_NAME__velocity[] = "velocity";
static char leo_msgs__msg__WheelStates__FIELD_NAME__torque[] = "torque";
static char leo_msgs__msg__WheelStates__FIELD_NAME__pwm_duty_cycle[] = "pwm_duty_cycle";

static rosidl_runtime_c__type_description__Field leo_msgs__msg__WheelStates__FIELDS[] = {
  {
    {leo_msgs__msg__WheelStates__FIELD_NAME__stamp, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_NESTED_TYPE,
      0,
      0,
      {builtin_interfaces__msg__Time__TYPE_NAME, 27, 27},
    },
    {NULL, 0, 0},
  },
  {
    {leo_msgs__msg__WheelStates__FIELD_NAME__position, 8, 8},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_FLOAT_ARRAY,
      4,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {leo_msgs__msg__WheelStates__FIELD_NAME__velocity, 8, 8},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_FLOAT_ARRAY,
      4,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {leo_msgs__msg__WheelStates__FIELD_NAME__torque, 6, 6},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_FLOAT_ARRAY,
      4,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {leo_msgs__msg__WheelStates__FIELD_NAME__pwm_duty_cycle, 14, 14},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_FLOAT_ARRAY,
      4,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

static rosidl_runtime_c__type_description__IndividualTypeDescription leo_msgs__msg__WheelStates__REFERENCED_TYPE_DESCRIPTIONS[] = {
  {
    {builtin_interfaces__msg__Time__TYPE_NAME, 27, 27},
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
leo_msgs__msg__WheelStates__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {leo_msgs__msg__WheelStates__TYPE_NAME, 24, 24},
      {leo_msgs__msg__WheelStates__FIELDS, 5, 5},
    },
    {leo_msgs__msg__WheelStates__REFERENCED_TYPE_DESCRIPTIONS, 1, 1},
  };
  if (!constructed) {
    assert(0 == memcmp(&builtin_interfaces__msg__Time__EXPECTED_HASH, builtin_interfaces__msg__Time__get_type_hash(NULL), sizeof(rosidl_type_hash_t)));
    description.referenced_type_descriptions.data[0].fields = builtin_interfaces__msg__Time__get_type_description(NULL)->type_description.fields;
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# This message describes the states of the wheels in Leo Rover\n"
  "#\n"
  "# The state of each wheel is defined by:\n"
  "#  * the position of the wheel (rad),\n"
  "#  * the velocity of the wheel (rad/s)\n"
  "#  * the torque that is applied in the wheel (Nm)\n"
  "#  * the PWM Duty cycle (%)\n"
  "#\n"
  "# The stamp specifies the time at which the wheel states were recorded.\n"
  "#\n"
  "# This message consists of a multiple arrays, one for each part of the wheel state.\n"
  "# The order of the wheels in each array is: FL, RL, FR, RR\n"
  "\n"
  "builtin_interfaces/Time stamp\n"
  "\n"
  "float32[4] position\n"
  "float32[4] velocity\n"
  "float32[4] torque\n"
  "float32[4] pwm_duty_cycle";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
leo_msgs__msg__WheelStates__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {leo_msgs__msg__WheelStates__TYPE_NAME, 24, 24},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 596, 596},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
leo_msgs__msg__WheelStates__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[2];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 2, 2};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *leo_msgs__msg__WheelStates__get_individual_type_description_source(NULL),
    sources[1] = *builtin_interfaces__msg__Time__get_individual_type_description_source(NULL);
    constructed = true;
  }
  return &source_sequence;
}
